<?

function win2uni($s)
{
$s = convert_cyr_string($s,'w','i'); // win1251 -> iso8859-5
// iso8859-5 -> unicode:
for ($result='', $i=0; $i<strlen($s); $i++) {
$charcode = ord($s[$i]);
$result .= ($charcode>175)?"&#".(1040+($charcode-176)).";":$s[$i];
}
return $result;
}

function GraphCircle($ar,$title) { $diagramWidth=600;
$diagramHeight=370;
$percents=array();
$legendOffset=50;

// asc val
//arsort($ar);

// desc val
//asort($gr_val);

// asc alph
//ksort($gr_val);

// desc alph
//krsort($gr_val);

$sum=0;
foreach ($ar as $name => $val) {
//    echo $name." - ".$val."<br>";
    $sum+=$val;
}

//echo "Total: ".$sum;

$sumless5=0;
$countless5=$countmore5=0;
foreach ($ar as $name => $val) {
//echo "<br>".$val/$sum;
    if ($val/$sum<0.01)
     { $sumless5+=$val;
       $countless5++;
       }
       else $countmore5++;
}
//echo "<br>Total: ".$sumless5." (".$countless5.")";



 // create image
$image = imageCreate($diagramWidth, $diagramHeight);

// allocate all required colors
$colorBackgr = imageColorAllocate($image, 220,220,220);
$colorText = imageColorAllocate($image, 0, 0, 0);
$colors[0] = imagecolorallocate($image, 255, 0, 0);
$colors[1] = imagecolorallocate($image, 0, 151, 0);
$colors[2] = imagecolorallocate($image, 0, 0, 255);
$colors[3] = imagecolorallocate($image, 255, 255, 0);
$colors[4] = imagecolorallocate($image, 0, 255, 255);
$colors[5] = imagecolorallocate($image, 204, 0, 206);
$colors[6] = imagecolorallocate($image, 155, 105, 27);
$colors[7] = imagecolorallocate($image, 134,188,134);
$colors[8] = imagecolorallocate($image, 255,189,62);
$colors[9] = imagecolorallocate($image, 168,168,255);
$colors[10] = imagecolorallocate($image, 219,255,111);
$colors[11] = imagecolorallocate($image, 255,201,200);
$colors[12] = imagecolorallocate($image, 0,169,168);
$colors[13] = imagecolorallocate($image, 248,255,213);
$colors[14] = imagecolorallocate($image, 255,106,105);
$colors[15] = imagecolorallocate($image, 133,133,133);
$colors[16] = imagecolorallocate($image, 194,255,255);
$colors[17] = imagecolorallocate($image, 90,9,255);
$colors[18] = imagecolorallocate($image, 109,255,110);
$colors[19] = imagecolorallocate($image, 255,133,22);


// clear the image space with the background color
imageFilledRectangle($image, 0, 0, $diagramWidth - 1, $diagramHeight - 1, $colorBackgr);
$flag=0;
$startAngle=0;
$perc=360/$sum;
$i=0;
foreach ($ar as $name => $val) {
  if ($val/$sum<0.01)	{ $flag=1; break; }
  $endAngle=$startAngle+$val*$perc;
  $percents[$i]=round(100*($val/$sum),2);
  // legend text
  imagefilledrectangle($image,285,$legendOffset+$i*15-9,295,$legendOffset+$i*15,$colors[$i]);
//  ImageString ($image, 4, 300, $legendOffset+$i*15, ($i+1).". ".$name." (".$percents[$i]." %)", $colorText);
  imagettftext ($image, 10, 0, 300, $legendOffset+$i*15, $colorText, "arialcyr.ttf", win2uni(($i+1).". ".$name." (".$percents[$i]." %)"));
  imagefilledarc($image, $diagramWidth/2-150, $diagramHeight/2, 200, 200, $startAngle, $endAngle, $colors[$i++], IMG_ARC_PIE);
  $startAngle=$endAngle;
}

if ($flag) {
// less than 5
  $endAngle=360;
  $percents[$i]=round(100*($sumless5/$sum),2);
  // legend text
  imagefilledrectangle($image,285,$legendOffset+$i*15-9,295,$legendOffset+$i*15,$colors[$i]);
//  ImageString ($image, 4, 300, $legendOffset+$i*15, ($i+1).". "."Other"." (".$percents[$i]." %)", $colorText);
  imagettftext ($image, 10, 0, 300, $legendOffset+$i*15, $colorText, "arialcyr.ttf", win2uni(($i+1).". ".""." (".$percents[$i]." %)"));
  imagefilledarc($image, $diagramWidth/2-150, $diagramHeight/2, 200, 200, $startAngle, $endAngle, $colors[$i++], IMG_ARC_PIE);
}

//  ImageString ($image, 5, 10, 10, $title, $colorText);
 imagettftext ($image, 14, 0, 10, 20, $colorText, "arialcyr.ttf", win2uni($title));

 imagettftext ($image, 10, 0, 10, $diagramHeight-10, $colorText, "arialcyr.ttf", "ASLogStat - www.aurorascorpio.com");

header("Content-type:  image/png");

imagepng($image);

// create an interlaced image for better loading in the browser
imageInterlace($image, 1);
// mark background color as being transparent
imageColorTransparent($image, $colorBackgr);


return;
}

function GraphBars($ar,$title) { $diagramWidth=500;
$diagramWidth2=450;
$diagramHeight=400;
$diagramHeight2=350;
$legendOffset=50;
$leftoffset=40;
$boxWidth=floor($diagramWidth2/count($ar));

$maxval=max($ar);

//echo $maxval;
$perc=$diagramHeight2/$maxval;

 // create image
$image = imageCreate($diagramWidth, $diagramHeight+100);

// allocate all required colors
$colorBackgr = imageColorAllocate($image, 220,220,220);
$colorText = imageColorAllocate($image, 0, 0, 0);
$w = imageColorAllocate($image, 255, 255, 255);
$colors[0] = imagecolorallocate($image, 182,110,29);
$colors[1] = imagecolorallocate($image, 132,64,255);
imageFilledRectangle($image, 0, 0, $diagramWidth - 1, $diagramHeight - 1, $colorBackgr);

$i=0;

//  imagefilledrectangle($image,100,100,10,20,$colors[1]);
$leftoffset2=$leftoffset;
foreach ($ar as $name => $val) {
  imagefilledrectangle($image,$leftoffset2,$diagramHeight-(25+ceil($perc*$val)),$leftoffset2+$boxWidth,$diagramHeight-25,$colors[($i%2)]);
//  imagefilledrectangle($image,10,200,30,325,$colors[1]);
 imagettftext ($image, 8, 270, $leftoffset2+($boxWidth/2)-5, $diagramHeight-20, $colorText, "arialcyr.ttf", win2uni($name));
//  ImageString ($image, 2, , , $name, $colorText);
  $i++;
  $leftoffset2+=$boxWidth;
}

  $style = array($colorText, $colorText, $colorText, $colorText, $colorText, $colorBackgr, $colorBackgr, $colorBackgr, $colorBackgr, $colorBackgr);
  imagesetstyle($image, $style);

//  ImageString ($image, 5, 10, 10, $title, $colorText);
 imagettftext ($image, 14, 0, 10, 18, $colorText, "arialcyr.ttf", win2uni($title));
  // Vertical scale
  // max
  ImageString ($image, 2, $leftoffset-20, $diagramHeight-(25+ceil($perc*$maxval)), $maxval, $colorText);
  imageline($image,$leftoffset-5, $diagramHeight-(25-1+ceil($perc*$maxval)),$leftoffset+$diagramWidth2,$diagramHeight-(25-1+ceil($perc*$maxval)),IMG_COLOR_STYLED);
  // 0
  ImageString ($image, 2, $leftoffset-20, $diagramHeight-25, 0, $colorText);
  imageline($image,$leftoffset-5, $diagramHeight-(25-1+ceil($perc*3*$maxval/4)),$leftoffset+$diagramWidth2,$diagramHeight-(25-1+ceil($perc*3*$maxval/4)),IMG_COLOR_STYLED);
  // 1/4
  ImageString ($image, 2, $leftoffset-20, $diagramHeight-(25+ceil($perc*($maxval/4))), ceil($maxval/4), $colorText);
  imageline($image,$leftoffset-5, $diagramHeight-(25-1+ceil($perc*$maxval/4)),$leftoffset+$diagramWidth2,$diagramHeight-(25-1+ceil($perc*$maxval/4)),IMG_COLOR_STYLED);
  // 1/2
  ImageString ($image, 2, $leftoffset-20, $diagramHeight-(25+ceil($perc*($maxval/2))), ceil($maxval/2), $colorText);
  imageline($image,$leftoffset-5, $diagramHeight-(25-1+ceil($perc*$maxval/2)),$leftoffset+$diagramWidth2,$diagramHeight-(25-1+ceil($perc*$maxval/2)),IMG_COLOR_STYLED);
  // 3/4
  ImageString ($image, 2, $leftoffset-20, $diagramHeight-(25+ceil($perc*(3*$maxval/4))), ceil(3*$maxval/4), $colorText);

  imageline($image,$leftoffset-1, $diagramHeight-25,$leftoffset-1, $diagramHeight-(25+ceil($perc*$maxval)), IMG_COLOR_STYLED);
 imagettftext ($image, 10, 0, 10, $diagramHeight+90, $colorText, "arialcyr.ttf", "ASLogStat - www.aurorascorpio.com");

header("Content-type:  image/png");
imagepng($image);
// create an interlaced image for better loading in the browser
imageInterlace($image, 1);
// mark background color as being transparent
imageColorTransparent($image, $colorBackgr);

return;
}



$gr_val=array("IE"=>150,"Firefox"=>60,"Opera"=>50);
$gr_val["Netscape"]=2;
$gr_val["Konqueror"]=7;
$gr_val["Mozilla"]=10;
$gr_val["Safari"]=10;

//GraphCircle($gr_val,"Browsers");

$gr_val=array("1"=>10,"2"=>8,"3"=>5);
$gr_val["4"]=2;
$gr_val["5"]=1;
$gr_val["6"]=4;
$gr_val["7"]=9;
$gr_val["8"]=15;
$gr_val["9"]=23;
$gr_val["10"]=34;
$gr_val["11"]=45;
$gr_val["12"]=57;
$gr_val["13"]=61;
$gr_val["14"]=58;
$gr_val["15"]=56;
$gr_val["16"]=46;
$gr_val["17"]=38;
$gr_val["18"]=48;
$gr_val["19"]=50;
$gr_val["20"]=31;
$gr_val["21"]=27;
$gr_val["22"]=12;
$gr_val["23"]=15;
$gr_val["24"]=17;


//GraphBars($gr_val,"Hosts a day");
?>